%define anolis_release 1
%global glib2_version 2.76.0

Name:           sysprof
Version:        47.2
Release:        %{anolis_release}%{?dist}
Summary:        A system-wide Linux profiler

License:        GPL-2.0-or-later AND GPL-3.0-or-later AND CC-BY-SA-4.0 AND BSD-2-Clause-Patent
URL:            http://www.sysprof.com
Source0:        https://download.gnome.org/sources/sysprof/47/sysprof-%{version}.tar.xz

# Backports of debuginfod and sysprof-live-unwinder from GNOME 48
Patch1:          0001-build-add-47-version-macros.patch
Patch2:          0002-libsysprof-elf-do-not-allow-setting-self-as-debug-li.patch
Patch3:          0003-libsysprof-elf-do-not-generate-fallback-names.patch
Patch4:          0004-sysprof-update-to-AdwSpinner.patch
Patch5:          0005-sysprof-add-SysprofDocumentTask-abstraction.patch
Patch6:          0006-libsysprof-add-setup-hooks-for-symbolizers.patch
Patch7:          0007-libsysprof-hoist-fallback-symbol-creation.patch
Patch8:          0008-libsysprof-add-debuginfod-symbolizer.patch
Patch9:          0009-libsysprof-ensure-access-to-process-info.patch
Patch10:         0010-libsysprof-fix-building-with-Ddebuginfod-auto.patch
Patch11:         0011-libsysprof-return-NULL-instance-unless-debuginfod-wo.patch
Patch12:         0012-build-always-build-debuginfod-symbolizer.patch
Patch13:         0013-libsysprof-remove-unnecessary-address-calculation.patch
Patch14:         0014-libsysprof-add-muxer-GSource.patch
Patch15:         0015-libsysprof-add-support-for-stack-regs-options-in-att.patch
Patch16:         0016-sysprofd-add-support-for-unwinding-without-frame-poi.patch
Patch17:         0017-libsysprof-add-SysprofUserSampler-for-live-unwinding.patch
Patch18:         0018-sysprof-cli-add-support-for-live-unwinding.patch
Patch19:         0019-sysprof-add-UI-for-live-unwinding.patch
Patch20:         0020-sysprof-live-unwinder-ifdef-unused-code-off-x86.patch
Patch21:         0021-sysprof-only-show-user-stack-sampling-on-x86.patch
Patch22:         0022-libsysprof-check-for-PERF_REG_EXTENDED_MASK-availabi.patch
Patch23:         0023-sysprof-live-unwinder-fix-source-func-prototype.patch
Patch24:         0024-sysprof-live-unwinder-handle-large-stack-unwind-size.patch
Patch25:         0025-unwinder-wait-for-completion-of-subprocess.patch
Patch26:         0026-sysprof-user-sampler-implement-await-for-FDs.patch
Patch27:         0027-libsysprof-provide-unwind-pipe-from-client.patch
Patch28:         0028-sysprof-live-unwinder-error-out-on-capture-failure.patch
Patch29:         0029-sysprofd-remove-unused-code.patch
Patch30:         0030-build-lower-libpanel-requirement-to-ease-some-build-.patch
Patch31:         0031-build-allow-await-for-FD-with-older-libdex.patch
Patch32:         0032-sysprof-default-stack-capturing-as-enabled.patch
Patch33:         0033-tests-fix-test-on-s390.patch

BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  gettext
BuildRequires:  itstool
BuildRequires:  meson
BuildRequires:  pkgconfig(gio-2.0) >= %{glib2_version}
BuildRequires:  pkgconfig(gio-unix-2.0) >= %{glib2_version}
BuildRequires:  pkgconfig(glib-2.0) >= %{glib2_version}
BuildRequires:  pkgconfig(gobject-2.0)
BuildRequires:  pkgconfig(gtk4)
BuildRequires:  pkgconfig(json-glib-1.0)
BuildRequires:  pkgconfig(libadwaita-1)
BuildRequires:  pkgconfig(libdex-1)
BuildRequires:  pkgconfig(libpanel-1)
BuildRequires:  pkgconfig(libsystemd)
BuildRequires:  pkgconfig(libunwind-generic)
BuildRequires:  pkgconfig(polkit-gobject-1)
BuildRequires:  pkgconfig(systemd)
BuildRequires:  pkgconfig(libdw)
BuildRequires:  pkgconfig(libdebuginfod)
BuildRequires:  /usr/bin/appstream-util
BuildRequires:  /usr/bin/desktop-file-validate

Requires:       glib2 >= %{glib2_version}
Requires:       hicolor-icon-theme
Requires:       %{name}-cli = %{version}-%{release}

%description
Sysprof is a sampling CPU profiler for Linux that collects accurate,
high-precision data and provides efficient access to the sampled
calltrees.

%package        agent
Summary:        Sysprof agent utility

%description    agent
The %{name}-agent package contains the sysprof-agent program. It provides a P2P
D-Bus API to the process which can control subprocesses. It's used by IDE
tooling to have more control across container boundaries.

%package        cli
Summary:        Sysprof command line utility
Requires:       kernel-tools
Requires:       libsysprof = %{version}-%{release}

%description    cli
The %{name}-cli package contains the sysprof-cli command line utility.


%package     -n libsysprof
Summary:        Sysprof libraries
Obsoletes:      libsysprof-ui < 45.0

%description -n libsysprof
The libsysprof package contains the Sysprof libraries.


%package        capture-devel
Summary:        Development files for sysprof-capture static library
License:        BSD-2-Clause-Patent
Provides:       sysprof-capture-static = %{version}-%{release}

%description    capture-devel
The %{name}-capture-devel package contains the sysprof-capture static library and header files.


%package        devel
Summary:        Development files for %{name}
Requires:       %{name}-capture-devel%{?_isa} = %{version}-%{release}
Requires:       libsysprof = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%prep
%autosetup -p1


%build
%meson
%meson_build


%install
%meson_install
%find_lang %{name} --with-gnome


%check
appstream-util validate-relax --nonet %{buildroot}%{_datadir}/metainfo/*.appdata.xml
desktop-file-validate %{buildroot}%{_datadir}/applications/*.desktop


%files
%license COPYING
%doc NEWS README.md AUTHORS
%{_bindir}/sysprof
%{_datadir}/applications/org.gnome.Sysprof.desktop
%{_datadir}/icons/hicolor/*/*/*
%{_datadir}/metainfo/org.gnome.Sysprof.appdata.xml
%{_datadir}/mime/packages/sysprof-mime.xml

%files agent
%license COPYING
%{_bindir}/sysprof-agent

%files cli -f %{name}.lang
%license COPYING
%{_bindir}/sysprof-cli
%{_libexecdir}/sysprofd
%{_libexecdir}/sysprof-live-unwinder
%{_datadir}/dbus-1/system.d/org.gnome.Sysprof3.conf
%{_datadir}/dbus-1/system-services/org.gnome.Sysprof3.service
%{_datadir}/polkit-1/actions/org.gnome.sysprof3.policy
%{_unitdir}/sysprof3.service

%files -n libsysprof
%license COPYING COPYING.gpl-2
%{_libdir}/libsysprof-6.so.6*
%{_libdir}/libsysprof-memory-6.so
%{_libdir}/libsysprof-speedtrack-6.so
%{_libdir}/libsysprof-tracer-6.so

%files capture-devel
%license src/libsysprof-capture/COPYING
%dir %{_includedir}/sysprof-6
%{_includedir}/sysprof-6/sysprof-address.h
%{_includedir}/sysprof-6/sysprof-capture-condition.h
%{_includedir}/sysprof-6/sysprof-capture-cursor.h
%{_includedir}/sysprof-6/sysprof-capture.h
%{_includedir}/sysprof-6/sysprof-capture-reader.h
%{_includedir}/sysprof-6/sysprof-capture-types.h
%{_includedir}/sysprof-6/sysprof-capture-writer.h
%{_includedir}/sysprof-6/sysprof-clock.h
%{_includedir}/sysprof-6/sysprof-collector.h
%{_includedir}/sysprof-6/sysprof-macros.h
%{_includedir}/sysprof-6/sysprof-platform.h
%{_includedir}/sysprof-6/sysprof-version.h
%{_includedir}/sysprof-6/sysprof-version-macros.h
%{_libdir}/libsysprof-capture-4.a
%{_libdir}/pkgconfig/sysprof-capture-4.pc

%files devel
%{_includedir}/sysprof-6/
%{_libdir}/libsysprof-6.so
%{_libdir}/pkgconfig/sysprof-6.pc
%{_datadir}/dbus-1/interfaces/org.gnome.Sysprof.Agent.xml
%{_datadir}/dbus-1/interfaces/org.gnome.Sysprof3.Profiler.xml
%{_datadir}/dbus-1/interfaces/org.gnome.Sysprof3.Service.xml

%changelog
* Fri Mar 21 2025 Bo Ren <rb01097748@alibaba-inc.com> - 47.2-1
- Update to 47.2-1 from 3.44.0
- Add sysprof-agent subpackage
- Remove libsysprof-ui
- Backport debuginfod and sysprof-live-unwinder
  [Patches cherry-picked from c10s. Original changelog:
   - Backport debuginfod and sysprof-live-unwinder (47.2-1)]

* Fri Jul 01 2022 happy_orange <songnannan@linux.alibaba.com> - 3.44.0-1
- Init package from upstrem
